# Filthy hack to convert ASCII 3ddump files of caves into filthy three.js code. 
# Writes labels on passages.
# Use: python ltconv <infile> <outfile>
# Import product into squiggle.html, 
# groups has coords for cave, p has bounding box of scene, labels 
# David Molnar June 2013

import string, math, sys			
			
f = open(sys.argv[1])
o = open(sys.argv[2], "w")

#get bounding box
es = []
ns = []
aas = []
mode = 0
for line in f:
	items = string.split(line.strip(), " ")
	if items[0]=="MOVE" or items[0]=="LINE":
		items[1]=float(items[1])
		items[2]=float(items[2])
		items[3]=float(items[3])
		
		es.append(float(items[1]))
		ns.append(float(items[2]))
		aas.append(float(items[3]))
		
ce = (max(es)+min(es))/2
cn = (max(ns)+min(ns))/2
ca = (max(aas)+min(aas))/2

xe = max(es)-ce
xn = max(ns)-cn
xa = max(aas)-ca

ne = min(es)-ce
nn = min(ns)-cn
na = min(aas)-ca

o.write("var p = new Array({}, {}, {}, {}, {}, {})\n".format(ne, na, nn, xe, xa, xn))

print xe, xn, xa
print ne, nn, na
print ce, cn, ca


#Write coords
f.seek(0)
o.write("var groups = [\n")
mode = 0
for line in f:
	items = string.split(line.strip(), " ")
	if items[0]=="MOVE" or items[0]=="LINE":
		items[1]=float(items[1])
		items[2]=float(items[2])
		items[3]=float(items[3])
	else:
		continue
	
	if items[0]=="MOVE":
		if mode == 2:
			o.write("\n], \n\n[\n")
		else:	
			o.write("\n[\n")
		
		o.write("\t[{},{},{}]".format(items[1]-ce, items[3]-ca, items[2]-cn))	
		es.append(float(items[1]))
		ns.append(float(items[2]))
		aas.append(float(items[3]))
		continue
	
	if items[0]=="LINE":
		o.write(",\n\t[{},{},{}]".format(items[1]-ce, items[3]-ca, items[2]-cn))
		mode=2
		
		es.append(float(items[1]))
		ns.append(float(items[2]))
		aas.append(float(items[3]))

					
if mode == 2:
	o.write("\n]\n")

o.write("]\n")

#Write labels
o.write("var labels = []\n")



		
	